ZAspect_SpellList = {
	ZHUNTER_ASPECT_HAWK,
	ZHUNTER_ASPECT_MONKEY,
	ZHUNTER_ASPECT_VIPER,
	ZHUNTER_ASPECT_CHEETAH,
	ZHUNTER_ASPECT_WILD,
	ZHUNTER_ASPECT_PACK,
	ZHUNTER_ASPECT_BEAST
}

ZAspect:SetScript("OnEvent", function(self, event, arg1, arg2)
	if event == "COMBAT_TEXT_UPDATE" then
		if arg1 == "AURA_START" or arg1 == "AURA_END" then
			ZAspect_CheckBuff(self, arg1, arg2)
		end
	elseif event == "PLAYER_DEAD" then
		self:ZSetTextures()
	elseif event == "PLAYER_LOGIN" then
		self:UnregisterEvent("PLAYER_LOGIN")
		self:RegisterEvent("COMBAT_TEXT_UPDATE")
		self:RegisterEvent("PLAYER_DEAD")
		ZHunterMod_Saved["ZAspect"]["spell"] = {}
		for i=1, 12 do
			local spell = ZAspect_SpellList[ZHunterMod_Saved["ZAspect"]["order"][i]]
			ZHunterMod_Saved["ZAspect"]["spell"][i] = spell
		end
		self.spells = ZHunterMod_Saved["ZAspect"]["spell"]
		self.anchorevent = ZHunterMod_Saved["ZAspect"]["event"]
		self.direction = ZHunterMod_Saved["ZAspect"]["direction"]
		self.size = ZHunterMod_Saved["ZAspect"]["size"]
		self.count = ZHunterMod_Saved["ZAspect"]["count"]
		ZSpellButton_SetupButton(self)
		ZAspect_CheckStartupBuffs()
		if ZHunterMod_Saved["ZAspect"]["on"] == 0 then
			ZAspect:Hide()
		end
	end
end)

function ZAspect_CheckBuff(frame, arg1, arg2)
	local name = frame:GetName()
	local i = 0
	local spell
	while frame do
		spell = frame:GetAttribute("spell")
		if spell == arg2 then
			if arg1 == "AURA_START" then
				frame.icon:SetTexture("Interface\\Icons\\Spell_Nature_WispSplode")
			elseif arg1 == "AURA_END" then
				local texture = GetSpellTexture(spell)
				frame.icon:SetTexture(texture)
			end
		end
		i = i + 1
		frame = getglobal(name..i)
	end
end

function ZAspect_CheckStartupBuffs()
	local buffs = {}
	for i=1, 40 do
		local buff = UnitBuff("player", i)
		if buff then
			buffs[buff] = true
		else
			break
		end
	end
	local frame = ZAspect
	local name = frame:GetName()
	local i = 0
	while frame do
		local spell = frame:GetAttribute("spell")
		if spell and buffs[spell] then
			frame.icon:SetTexture("Interface\\Icons\\Spell_Nature_WispSplode")
		else
			local texture = GetSpellTexture(spell or "")
			if texture then
				frame.icon:SetTexture(texture)
			end
		end
		i = i + 1
		frame = getglobal(name..i)
	end
end