function ZHunterModSpellSizeSlider_OnValueChanged(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(value)
	ZHunterMod_Saved[addon or ""]["size"] = value
	local frame = getglobal(addon)
	if frame then
		frame:ZSetSize(value)
	end
end

function ZHunterModSpellCountSlider_OnValueChanged(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(value)
	ZHunterMod_Saved[addon or ""]["count"] = value
	local frame = getglobal(addon)
	if frame then
		frame:ZSetCount(value)
	end
end

function ZHunterModSpellRowSlider_OnValueChanged(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(value)
	ZHunterMod_Saved[addon or ""]["row"] = value
	local frame = getglobal(addon)
	if frame then
--		frame:ZSetLayout(value)
	end
end

function ZHunterModSpellOrder_PlusClicked(self)
	local id = self:GetParent():GetID()
	if id == 1 then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local order = ZHunterMod_Saved[addon or ""]["order"][(id - 1)]
	local spell = ZHunterMod_Saved[addon or ""]["spell"][(id - 1)]
	ZHunterMod_Saved[addon or ""]["order"][(id - 1)] = ZHunterMod_Saved[addon or ""]["order"][id]
	ZHunterMod_Saved[addon or ""]["spell"][(id - 1)] = ZHunterMod_Saved[addon or ""]["spell"][id]
	ZHunterMod_Saved[addon or ""]["order"][id] = order
	ZHunterMod_Saved[addon or ""]["spell"][id] = spell
	local prev = getglobal("ZHunterModSpellOrderOptionsOrder"..(id - 1).."Text")
	local curr = getglobal("ZHunterModSpellOrderOptionsOrder"..id.."Text")
	prev:SetText(ZHunterMod_Saved[addon or ""]["spell"][(id - 1)])
	curr:SetText(spell)
	getglobal(addon):ZSetSpells()
end

function ZHunterModSpellOrder_MinusClicked(self)
	local id = self:GetParent():GetID()
	local next = getglobal("ZHunterModSpellOrderOptionsOrder"..(id + 1))
	if not next or not next:IsVisible() then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local order = ZHunterMod_Saved[addon or ""]["order"][(id + 1)]
	local spell = ZHunterMod_Saved[addon or ""]["spell"][(id + 1)]
	ZHunterMod_Saved[addon or ""]["order"][(id + 1)] = ZHunterMod_Saved[addon or ""]["order"][id]
	ZHunterMod_Saved[addon or ""]["spell"][(id + 1)] = ZHunterMod_Saved[addon or ""]["spell"][id]
	ZHunterMod_Saved[addon or ""]["order"][id] = order
	ZHunterMod_Saved[addon or ""]["spell"][id] = spell
	next = getglobal("ZHunterModSpellOrderOptionsOrder"..(id + 1).."Text")
	local curr = getglobal("ZHunterModSpellOrderOptionsOrder"..id.."Text")
	next:SetText(ZHunterMod_Saved[addon or ""]["spell"][(id + 1)])
	curr:SetText(spell)
	getglobal(addon):ZSetSpells()
end

function ZHunterModSpellMore_OnClick(self)
	if ZHunterModSpellButtonOptions:IsVisible() then
		ZHunterModSpellButtonOptions:Hide()
		ZHunterModSpellOrderOptions:Show()
	else
		ZHunterModSpellButtonOptions:Show()
		ZHunterModSpellOrderOptions:Hide()
	end
end

function ZHunterModOptions_Enabled(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local frame = getglobal(addon or "")
	if self:GetChecked() then
		ZHunterMod_Saved[addon or ""]["on"] = 1
		if frame then
			frame:Show()
		end
	else
		ZHunterMod_Saved[addon or ""]["on"] = 0
		if frame then
			frame:Hide()
		end
	end
end

function ZHunterModOptions_SetupMenuItems()
	ZHunterModSpellSizeSlider:SetMinMaxValues(10, 56)
	ZHunterModSpellCountSlider:SetMinMaxValues(1, 12)
	ZHunterModSpellRowSlider:SetMinMaxValues(1, 12)
	ZHunterModSpellSizeSlider:SetValueStep(1)
	ZHunterModSpellCountSlider:SetValueStep(1)
	ZHunterModSpellRowSlider:SetValueStep(1)
	UIDropDownMenu_Initialize(ZHunterModSpellShowDropDown, ZHunterModSpellShowDropDown_Update)
	UIDropDownMenu_Initialize(ZHunterModSpellExpandDropDown, ZHunterModSpellExpandDropDown_Update)
	UIDropDownMenu_Initialize(ZHunterModSpellRowDropDown, ZHunterModSpellRowDropDown_Update)
end

function ZHunterModAddOnDropDown_Update()
	local info = {}
	info.func = ZHunterModAddOnDropDown_OnClick
	info.notCheckable = 1
	local t = {"ZAspect", "ZTrack", "ZTrap", "ZPet", "ZAutoShot", "ZAutoStrip", "ZTranqShot"}
	for i=1, 7 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellShowDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellShowDropDown_OnClick
	info.notCheckable = 1
	local t = {"OnMouseOver", "OnRightClick", "Always"}
	for i=1, 3 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellExpandDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellExpandDropDown_OnClick
	info.notCheckable = 1
	local t = {"LEFT", "RIGHT", "TOP", "BOTTOM"}
	for i=1, 4 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellRowDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellRowDropDown_OnClick
	info.notCheckable = 1
	local t = {"TOP", "BOTTOM"}
	for i=1, 2 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModAddOnDropDown_OnClick()
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = this.value
	ZHunterModAddOnDropDownText:SetText(value)
	ZHunterModOptionEnabled:SetChecked(ZHunterMod_Saved[value or ""]["on"])
	if value == "ZAspect" or value == "ZTrack" or value == "ZTrap" or value == "ZPet" then
		ZHunterModSpellSizeSlider:SetValue(ZHunterMod_Saved[value or ""]["size"])
		ZHunterModSpellCountSlider:SetValue(ZHunterMod_Saved[value or ""]["count"])
		ZHunterModSpellRowSlider:SetValue(ZHunterMod_Saved[value or ""]["row"])
		ZHunterModSpellShowDropDownText:SetText(ZHunterMod_Saved[value or ""]["event"])
		ZHunterModSpellExpandDropDownText:SetText(ZHunterMod_Saved[value or ""]["direction"])
		ZHunterModSpellRowDropDownText:SetText(ZHunterMod_Saved[value or ""]["stack"])
		for i=1, 12 do
			local button = getglobal("ZHunterModSpellOrderOptionsOrder"..i.."Text")
			local spell = ZHunterMod_Saved[value]["spell"][i]
			if spell then
				button:SetText(spell)
				button:GetParent():Show()
			else
				button:GetParent():Hide()
			end
		end
		ZHunterModSpellButtonOptions:Show()
		ZHunterModSpellMore:Show()
	else
		ZHunterModSpellButtonOptions:Hide()
		ZHunterModSpellMore:Hide()
	end
	ZHunterModSpellOrderOptions:Hide()
end

function ZHunterModSpellShowDropDown_OnClick()
	local value = this.value
	ZHunterModSpellShowDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["event"] = value
	local frame = getglobal(addon)
	if frame then
		frame:ZSetAnchorEvent(value)
	end
end

function ZHunterModSpellExpandDropDown_OnClick()
	local value = this.value
	ZHunterModSpellExpandDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["direction"] = value
	local frame = getglobal(addon)
	if frame then
		frame:ZSetLayout(value)
	end
end

function ZHunterModSpellRowDropDown_OnClick()
	local value = this.value
	ZHunterModSpellRowDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["row"] = value
	local frame = getglobal(addon)
	if frame then
--		frame:ZSetLayout(value)
	end
end

function ZHunterModOptionsMenu_Load()
	ZHunterModOptionsMenu:Show()
end

SLASH_ZHunter1 = "/ZHunter"
SLASH_ZHunter2 = "/ZHunterMod"
SlashCmdList["ZHunter"] = function(msg)
	ZHunterModOptionsMenu_Load()
end